'--------------------------   --------------------------------
Declare  SHOW_SYSTEM_VARIABLES = OFF   '    Proteus    
Declare  FSR_CONTEXT_SAVE = OFF        '       FSR
Declare  Reminders = OFF               '    
Declare  Warnings = OFF                '    
Declare  Optimiser_Level 0             '    
                                                                   
;--------------------------  ------------------------------------
Device = 16F628A   '  
Xtal = 20          '    20 
                                                                   
'--------------------------    ------------------------
Declare  LCD_Type ALPHA       '   -  -
Declare  LCD_DTPin  PORTB.4   '   
Declare  LCD_ENPin  PORTB.3   '   E
Declare  LCD_RSPin  PORTB.2   '   RS
Declare  LCD_Interface  4     '   
Declare  LCD_CommandUs  2000  '    
Declare  LCD_DataUs  50       '    
Declare  LCD_Lines   2        '   
                                                                   
'--------------------------   ---------------------------------
PortB_Pullups = OFF        '     PORTB
Declare  All_Digital = OFF '       

TRISA = %00000111
TRISB = %00000001
                                                                   
'--------------------------   -------------------
CMCON = %00000010   '  
VRCON = %10001001   '    1.88                                                                     

'-------------------------- INTCON --------------------------------------------
Symbol RBIF = INTCON.0 '     PORTB.4-PORTB.7
Symbol INTF = INTCON.1 '     PORTB.0(INT)
Symbol T0IF = INTCON.2 '   TMR0
Symbol RBIE = INTCON.3 '     PORTB.4-PORTB.7
Symbol INTE = INTCON.4 '     PORTB.0(INT) 
Symbol T0IE = INTCON.5 '      TMR0
Symbol PEIE = INTCON.6 '      
Symbol GIE = INTCON.7  '    
                                                                   
'-------------------------- PIE1, PIR1 ----------------------------------------------
Symbol TMR1IE = PIE1.0 '      TMR1
Symbol TMR1IF = PIR1.0 '     TMR1
                                                                   
'-------------------------- T1CON ---------------------------------------------------
Symbol TMR1ON = T1CON.0     '    TMR1 
Symbol TMR1CS = T1CON.1     '      TMR1
Symbol NOT_T1SYNC = T1CON.2 '    
Symbol T1INSYNC = T1CON.2   '    
Symbol T1SYNC = T1CON.2     '    
Symbol T1OSCEN = T1CON.3    '    TMR1
Symbol T1CKPS0 = T1CON.4    '     TMR1
Symbol T1CKPS1 = T1CON.5    '     TMR1



Symbol CMIF = PIR1.6 '     
Symbol CMIE = PIE1.6 '     

'--------------------------  -------------------------------------------
Dim i As Dword
 Dim q As Byte
'--------------------------  TMR1   --------------------
TMR1L = $CE       '    TMR1
TMR1H = $FF       '    TMR1
T1CON = %00000000
TMR1IE = 1        '     TMR1   100000,000000 


CMIE = 1 '    
PEIE = 1 ' Ht                                                                    
GIE = 1  '   


On_Interrupt GoTo  Int_Label
GoTo  MainProgram
'-------------------------- --------------------------
Int_Label:
Context Save                     '                                  
 If CMIF = 1 Then                '   
  If CMCON.6 = 1 Then
   TMR1ON = 1 '       ,   TMR1
   i = 0
  EndIf 
  If CMCON.6 = 0 Then TMR1ON = 0 '       ,   TMR1
  q = CMCON
  CMIF = 0                       '     
 EndIf
 
 If TMR1IF = 1 Then '   TMR1
  TMR1L = $CE                    '    TMR1
  TMR1H = $FF                    '    TMR1
  Inc i             '  "i"
  TMR1IF = 0        '      TMR1
 EndIf                                                                     
Context Restore                '    
                                                                   
'--------------------------   -------------------------

MainProgram:
 DelayMS 50
If TMR1ON = 0 Then
 Print At 1,1, Dec i '     "i"
EndIf
GoTo  MainProgram   '     
                                                                   
                                                                   

